
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/commodities.h>

__saveds void cxfunct (CxMsg *cxmsg,CxObj *cxobj)

{
struct InputEvent *ie = (struct InputEvent *) CxMsgData (cxmsg);
UWORD qual = ie->ie_Qualifier;

if (ie->ie_Class == IECLASS_RAWMOUSE)
	{
	UWORD code = ie->ie_Code & ~IECODE_UP_PREFIX;
	if (code == IECODE_LBUTTON || code == IECODE_RBUTTON)
		ie->ie_Code ^= 1;
	}

ie->ie_Qualifier &= ~(IEQUALIFIER_LEFTBUTTON | IEQUALIFIER_RBUTTON);

if (qual & IEQUALIFIER_LEFTBUTTON)
	ie->ie_Qualifier |= IEQUALIFIER_RBUTTON;

if (qual & IEQUALIFIER_RBUTTON)
	ie->ie_Qualifier |= IEQUALIFIER_LEFTBUTTON;
}


int main (void)

{
struct MsgPort *cxport;
CxObj *broker;
CxObj *cx;
long error = 0;
CxMsg *cxmsg;
ULONG sigs,cxsig;
BOOL cont;
static struct NewBroker nb = {
	NB_VERSION,
	"ButtonSwap",
	"swap mouse buttons",
	"swaps left an right mouse buttons",
	NBU_UNIQUE | NBU_NOTIFY,
	0, /* COF_SHOW_HIDE, */
	100,
	NULL,
	0
	};


if (cxport = CreateMsgPort ())
	{
	nb.nb_Port = cxport;

	if (broker = CxBroker (&nb,&error))
		{
		if (cx = CxCustom (cxfunct,0))
			{
			AttachCxObj (broker,cx);
			ActivateCxObj (broker,TRUE);

			cxsig = 1L << cxport->mp_SigBit;

			cont = TRUE;
			do	{
				sigs = Wait (cxsig | SIGBREAKF_CTRL_C);

				if (sigs & SIGBREAKF_CTRL_C)
					cont = FALSE;

				if (sigs & cxsig)
					{
					while (cxmsg = (CxMsg *) GetMsg (cxport))
						{
						switch (CxMsgType (cxmsg))
							{
						case CXM_IEVENT:
							break;
						case CXM_COMMAND:
							switch (CxMsgID (cxmsg))
								{
							case CXCMD_DISABLE:
								ActivateCxObj (broker,FALSE);
								break;
							case CXCMD_ENABLE:
								ActivateCxObj (broker,TRUE);
								break;
							case CXCMD_KILL:
								cont = FALSE;
								break;
						/*	case CXCMD_APPEAR:
								Printf ("SHOW\n");
								break;
							case CXCMD_DISAPPEAR:
								Printf ("HIDE\n");
								break;
						*/	case CXCMD_UNIQUE:
							/*	Printf ("SHOW\n"); */	/* show gui if one exists */
								cont = FALSE;			/* quit if no gui exists */
								break;
								}
							break;
							}
						ReplyMsg ((struct Message *)cxmsg);
						}
					}
				}
			while (cont);
			}

		DeleteCxObjAll (broker);

		while (cxmsg = (CxMsg *) GetMsg (cxport))
			ReplyMsg ((struct Message *)cxmsg);
		}
	else
		Printf ("error = %ld\n",error);

	DeleteMsgPort (cxport);
	}

return (0);
}

